=== debian/changelog ===
lammps (20251210+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - update debian/copyright for dropped src lib dirs compress kim
      netcdf python quip voronoi vtk awpmd poems. EXAMPLES are still
      available.
    - Build-Depends-Indep: python3-sphinx-sitemap
  * build EXTRA-COMPUTE package to enable calculation of stress tensor
    profiles
  * Improve cross build satisfiability. Closes: Bug#1108103
    + Annotate gfortran dependency with -for-host and let dpkg's
      buildtools.mk supply the prefixed fortran compiler.
    + Move all sphinx dependencies to B-D-I.
    + Multiarchify python B-D.
    + patch by Helmut Grohne
  * after dh_auto_clean: delete generated doc files: doc/html,
    various doc/src/*s.rst, doc/utils/.../lammps_theme/search.html
  * update debian patch 20_set_potentials_path.patch to current
    Python API (PyUnicode_FromString)
  * drop redundant debian/source/lintian-overrides
    source-is-missing [doc/html/*.html] is now mismatched
  * Standards-Version: 4.7.3

 -- Drew Parsons <dparsons@debian.org>  Fri, 02 Jan 2026 02:42:27 +1100
